// 2020.6.23 修改经销商
// 百度地图API功能
var map = new BMap.Map("allmap"); // 创建Map实例
map.centerAndZoom("武汉", 11); //指定中心城市
// map.enableScrollWheelZoom(flase); //开启鼠标滚轮缩放
var navigationControl = new BMap.NavigationControl({
    // 靠左上角位置
    anchor: BMAP_ANCHOR_TOP_LEFT,
    // LARGE类型
    type: BMAP_NAVIGATION_CONTROL_LARGE,
    // 启用显示定位
    enableGeolocation: true
});
map.addControl(navigationControl);
map.setMapStyle({style: 'googlelite'});

var _province_id = "province";
var _city_id = "city";

var global_province = "湖北";
var global_city = "武汉";
var my_point_lng = 114.313527;
var my_point_lat = 30.584255;
var state = 0; //状态 0:未定位 1:城市级非精准定位 2：精准定位
var seachtimes = -2;

init_data();
$(function () {
    //高德浏览器精确定位
    AMap.plugin('AMap.Geolocation', function () {
        var geolocation = new AMap.Geolocation({
            enableHighAccuracy: true//是否使用高精度定位，默认:true
        });
        geolocation.getCurrentPosition(function (status, result) {
            if (status == 'complete') {
                state = 2;
                //my_point_lng=result.position.lng;
                //my_point_lat=result.position.lat;
                global_province = result.addressComponent.province;
                global_city = (result.addressComponent.city == "") ? result.addressComponent.province : result.addressComponent.city;
                //百度 经纬度转换 高德转百度
                new BMap.Convertor().translate([new BMap.Point(result.position.lng, result.position.lat)], 3, 5, function (data) {
                    if (data.status === 0) {
                        my_point_lng = data.points[0].lng;
                        my_point_lat = data.points[0].lat;
                        locate();
                    }
                });
            } else {
                //高德IP查询
                AMap.plugin('AMap.CitySearch', function () {
                    new AMap.CitySearch().getLocalCity(function (status, r) {
                        if (status === 'complete' && r.info === 'OK') {
                            state = 1;
                            global_province = r.province;
                            global_city = r.city;
                            my_point_lng = (parseFloat(r.rectangle.split(";")[0].split(",")[0]) + parseFloat(r.rectangle.split(";")[1].split(",")[0])) / 2;
                            my_point_lat = (parseFloat(r.rectangle.split(";")[0].split(",")[1]) + parseFloat(r.rectangle.split(";")[1].split(",")[1])) / 2;
                            locate();
                        }
                    });
                });
            }
        });
    });
});
//定位成功后 改变省市选择
var pros = PROVINCEDATA;
var citys = CITYDATA;
var dealers = DEALREDATA;

function locate() {
    if (seachtimes < 1) {//判断查询次数 没有人为修改省市后执行
        $("#" + _province_id).empty().append("<option value=''>请选择省份</option>");
        for (i = 0; i < pros.length; i++) {
            $("#" + _province_id).append("<option value=" + pros[i].id + ">" + pros[i].name + "</option>");
            if (global_province.indexOf(pros[i].name) != -1) {
                $("#" + _province_id + " option").eq(i + 1).prop("selected", true).siblings().prop("selected", false);
                $("#" + _province_id).prev().text(pros[i].name);
            }
        }
        $("#" + _province_id).trigger("change");
    }
}

function init_data() {
    $("#" + _province_id).on("change", function () {
        var proId = $(this).val();
        $(this).prev().text($(this).find("option:selected").text());
        $("#" + _city_id).empty().append("<option value=''>请选择城市</option>");
        seachtimes++;
        if (proId != "") {
            for (var j = 0; j < citys.length; j++) {
                if (citys[j].pid == proId) {
                    $("#" + _city_id).append("<option value='" + citys[j].id + "'" + ((global_city.indexOf(citys[j].name) != -1) ? " selected" : "") + ">" + citys[j].name + "</option>");
                }
            }
            $("#" + _city_id).trigger("change");
        }
    });
    $("#" + _city_id).on("change", function () {
        var cityId = $(this).val();
        $(this).prev().text($(this).find("option:selected").text());
        seachtimes++;
        if (cityId != "") {
            dealer_json = [];
            for (var k = 0; k < dealers.length; k++) {
                if (dealers[k].cid == cityId) {
                    dealer_json.push(dealers[k])
                }
            }
            handleDealer();
        }
    });
}

//获取指定城市经销商
function handleDealer() {
    if (state > 0 && $("#city").find("option:selected").text() == "武汉") {
        for (var i = 0; i < dealer_json.length; i++) {
            switch (dealer_json[i].id) {
                case "612":
                    dealer_json[i].distance = 1;
                    break;
                case "205":
                    dealer_json[i].distance = 2;
                    break;
                case "364":
                    dealer_json[i].distance = 3;
                    break;
                case "291":
                    dealer_json[i].distance = 4;
                    break;
                case "16":
                    dealer_json[i].distance = 5;
                    break;
                case "242":
                    dealer_json[i].distance = 6;
                    break;
                case "424":
                    dealer_json[i].distance = 7;
                    break;
                case "293":
                    dealer_json[i].distance = 8;
                    break;
            }
        }
        sortdealer();
    } else
      //演示临时end
    if (state == 2 && global_city.indexOf($("#city").find("option:selected").text()) != -1) {//判断是否精准定位下的定位城市
        //计算距离
        for (var i = 0; i < dealer_json.length; i++) {
            dealer_json[i].distance = getGreatCircleDistance(my_point_lng, my_point_lat, Number(dealer_json[i].lat), Number(dealer_json[i].lon));
        }
        sortdealer();
    } else {

        for (var i = 0; i < dealer_json.length; i++) {
            dealer_json[i].distance = getGreatCircleDistance(my_point_lng, my_point_lat, Number(dealer_json[i].lat), Number(dealer_json[i].lon));
        }
        sortdealer()
    }
}

function sortdealer() {
    //数据按距离排序
    for (var j = 0; j < dealer_json.length - 1; j++) {
        for (var i = 0; i < dealer_json.length - 1 - j; i++) {
            if (dealer_json[i].distance > dealer_json[i + 1].distance) {
                var temp = dealer_json[i];
                dealer_json[i] = dealer_json[i + 1];
                dealer_json[i + 1] = temp;
            }
        }
    }
    initPointer();
}

//初始化坐标函数
function initPointer() {
    //清空操作
    var ci = $("#city").find("option:selected").text();
    var _arr_info = [];
    map.clearOverlays();
    map.centerAndZoom(ci, 11);
    var htmllist = '';
    var pointArray = new Array();
    var marker = new Array();
    var infoWindow = new Array();
    $.each(dealer_json, function (i, n) {
        //放入百度地图
        pointArray[i] = new BMap.Point(n.lat, n.lon);
        marker[i] = new BMap.Marker(pointArray[i], {
            icon: new BMap.Icon("images/icon_" + i + ".png", new BMap.Size(30, 35))
        }); // 创建标注
        map.addOverlay(marker[i]); // 将标注添加到地图中
        infoWindow[i] = new BMap.InfoWindow("地址：" + n.address + "<br />销售热线: " + n.fwtel + "<br />售后热线: " + n.tel + "", {
            width: 300,
            height: 110,
            title: n.name,
            enableMessage: true
        }); // 创建信息窗口对象
        marker[i].addEventListener("onmouseover", function () {
            map.openInfoWindow(infoWindow[i], pointArray[i]); //开启信息窗口
        });

        //创建右侧列表
        htmllist += '<li><img src="images/icon_' + i + '.png" />';
        htmllist += '<h5>' + n.name + '</h5>';
        htmllist += '<div class="info-box"><p>' + n.address + '</p>';
        htmllist += '<p>销售热线：' + n.fwtel + '</p>';
        htmllist += '<p>售后热线：' + n.tel + '</p></div></li>';
    });
    map.setViewport(pointArray);
    //存入html中
    $('.pos-result-box').empty().html(htmllist);
    //设置分页
    $("div.holder").jPages({
        containerID: "itemContainer",
        perPage: 3,
        previous: true,
        next:true
    });
}


//经纬度距离计算。单位米
var EARTH_RADIUS = 6378137.0;    //单位M
var PI = Math.PI;

function getRad(d) {
    return d * PI / 180.0;
}

function getGreatCircleDistance(lat1, lng1, lat2, lng2) {
    var radLat1 = getRad(lat1);
    var radLat2 = getRad(lat2);

    var a = radLat1 - radLat2;
    var b = getRad(lng1) - getRad(lng2);

    var s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)));
    s = s * EARTH_RADIUS;
    s = Math.round(s * 10000) / 10000.0;

    return s;
}
